﻿#region

using System;
using System.Diagnostics;
using System.Linq;
using System.Text;
using Allen.APCAPI;
using Allen.APCAPI.Messages;

#endregion

namespace MLi_Connection_Test
{
    class Program
    {
        private static readonly APCAPI _api = new APCAPI();
        static void Main(string[] args)
        {  
            _api.Open("rs232://COM1:115200,8,N,1,None");
            //_api.Open("tcpip://192.168.173.65:30001"); 

            if (_api.IsConnected)
            {               
                _api.OnNotificationRecieved+=NotificationRecieved;
                Console.WriteLine(_api.Methods.GET_VERSION_INFORMATION(true));
                 
                foreach (var configkey in _api.Methods.CONFIG_LISTKEYS())
                {
                    Console.WriteLine(configkey);
                }
            }

            Console.WriteLine("Press ESC to stop");
            do
            {
                while (!Console.KeyAvailable)
                { 
                }
            } while (Console.ReadKey(true).Key != ConsoleKey.Escape);

            _api.CloseDevice();  
        }

        private static void NotificationRecieved(object sender, IMessage eventData)
        {
            var notification = eventData as NotificationMessage;
            if (notification != null)
            { 
                var notificationID = (APCAPI.NOTIFICATIONID)notification.Notification.NOTIFICATION_ID;

                switch (notificationID)
                {
                    case APCAPI.NOTIFICATIONID.NOTIFY_INIT:
                        Console.WriteLine(notificationID + Environment.NewLine);
                        break;

                    case APCAPI.NOTIFICATIONID.NOTIFY_HELLO:
                        Console.WriteLine(notificationID + Environment.NewLine);
                        break;

                    case APCAPI.NOTIFICATIONID.NOTIFY_BOOTCOMPLETE:
                        Console.WriteLine(notificationID + Environment.NewLine);
                        break;

                    case APCAPI.NOTIFICATIONID.NOTIFY_READY:
                        Console.WriteLine(notificationID + Environment.NewLine);
                        break;

                    case APCAPI.NOTIFICATIONID.NOTIFY_IDLE:
                        Console.WriteLine(notificationID + Environment.NewLine);
                        break;

                    case APCAPI.NOTIFICATIONID.NOTIFY_ERROR:
                        int errorModule = notification.Notification.DATA.ToArray()[0];
                        int errorcode = notification.Notification.DATA.ToArray()[1];
                        var errorText = Encoding.UTF8.GetString(notification.Notification.DATA.ToArray().Skip(2).ToArray());
                        Console.WriteLine(notificationID + " " + errorModule + " " + errorcode + " " + errorText + Environment.NewLine);                         
                        break;

                    case APCAPI.NOTIFICATIONID.NOTIFY_WARN:
                        int warningModule = notification.Notification.DATA.ToArray()[0];
                        int warningcode = notification.Notification.DATA.ToArray()[1];
                        var warningText = Encoding.UTF8.GetString(notification.Notification.DATA.ToArray().Skip(2).ToArray());
                        Console.WriteLine(notificationID+ " " + warningModule + " " + warningcode + " " + warningText + Environment.NewLine);
                        break;

                    case APCAPI.NOTIFICATIONID.NOTIFY_INFO:
                        int infoModule = notification.Notification.DATA.ToArray()[0];
                        int infocode = notification.Notification.DATA.ToArray()[1];
                        var infoText = Encoding.UTF8.GetString(notification.Notification.DATA.ToArray().Skip(2).ToArray());
                        Console.WriteLine(notificationID+ " " + infoModule + " " + infocode + " " + infoText + Environment.NewLine);
                        break;

                    case APCAPI.NOTIFICATIONID.NOTIFY_USERMESSAGE:
                        Console.WriteLine(notificationID + Encoding.ASCII.GetString(notification.Notification.DATA) + Environment.NewLine);
                        break;

                    case APCAPI.NOTIFICATIONID.NOTIFY_PRINTED:
                        Console.WriteLine(notificationID+ Environment.NewLine);
                        Console.WriteLine("printcounter:" + notification.Notification.DATA[0]);
                        break;

                    case APCAPI.NOTIFICATIONID.NOTIFY_PRINT_LOST:
                        Debug.WriteLine(notificationID + Environment.NewLine);
                        break;

                    case APCAPI.NOTIFICATIONID.NOTIFY_CASECOVER_CLOSE:
                        Console.WriteLine(notificationID+ Environment.NewLine); 
                        break;

                    case APCAPI.NOTIFICATIONID.NOTIFY_NEED_VARIABLE_DATA:
                        Console.WriteLine(notificationID+ Environment.NewLine); 
                        break;
                }
            }
        }
    }
}